/*
 * Created on 2004/10/07
 * Author aki@www.xucker.jpn.org
 * License Apache2.0 or Common Public License
 */
package org.jpn.xucker.commons.util;

/**
 * 
 *
 */
public interface ApplicationProperties {
    public boolean isChanged();
    public void setChanged(boolean bool);
    public abstract void set(String key, int value);

    public abstract void remove(String key);

    public abstract void set(String key, String value);

    public abstract String[] getKeys();

    public abstract String get(String key);

    public abstract String get(String key, String defaultValue);

    public abstract void save();
    public void load();

  

    /**
     * @param show_normal_html
     * @return
     */
    public abstract boolean getBoolean(String key);
    public abstract boolean getBoolean(String key,boolean defaultValue);
    /**
     * @param show_normal_html
     * @param selection
     */
    public abstract void setBoolean(String key, boolean selection);

    /**
     * @return
     */
    public abstract boolean avaiable();
}