/*
 * Created on 2004/10/03
 * Author aki@www.xucker.jpn.org
 * License Apache2.0 or Common Public License
 */
package org.jpn.xucker.commons.audio.word;

import java.io.File;

import org.jpn.xucker.commons.audio.FileAudioPlayer;

/**
 * 
 *
 */
public class LocalFilePlainWordPlayer extends AbstractWordPlayer{

    private String path;
    private FileAudioPlayer player;
    
    
    
    
    public LocalFilePlainWordPlayer(String path){
        this.path=path;
    }
    
    public LocalFilePlainWordPlayer(String path,FileAudioPlayer player){
        this.path=path;
        this.player=player;
    }
    
    public FileAudioPlayer getPlayer() {
        return player;
    }
    public void setPlayer(FileAudioPlayer player) {
        this.player = player;
    }
    /* (non-Javadoc)
     * @see org.jpn.xucker.commons.audio.sp.WordAudioPlayer#play(java.lang.String)
     */
    public void play(String word) {
    File file=getWordFile(word);
    if(file.exists() && player!=null){
        player.play(file);
    }
    }

    /* (non-Javadoc)
     * @see org.jpn.xucker.commons.audio.sp.WordAudioPlayer#exist(java.lang.String)
     */
    
    private File getWordFile(String word){
        
        File wordFile=null;
    
       
        
        return wordFile;
    }
    public boolean exist(String word) {
        File file=getWordFile(word);
        return file!=null && file.exists();
    }
    
    public void setBaseDirectoryPath(String path){
        this.path=path;
    }


}
