/*
 * Created on 2005/02/27
 * Author aki@www.xucker.jpn.org
 * License Apache2.0 or Common Public License
 */
package org.jpn.xucker.commons.swt.ui;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.RowData;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

import java.io.IOException;



/**
 * 
 *
 */
public class ConfirmFileOverwriteDialog extends Dialog implements SelectionListener{
public static final int YES=0;
public static  final int NO=1;
public static  final int CANCELL=2;
public static  final int ALL_YES=3;
public static  final int ALL_NO=4;

public static String YES_LABEL="͂";
public static String NO_LABEL="";
public static String CANCELL_LABEL="LZ";
public static String ALL_YES_LABEL="ȍ~ ׂ ͂";
public static String ALL_NO_LABEL="ȍ~ ׂ ";

private static String message="t@C\n%FILE\n͂łɑ݂܂Bt@C㏑܂?";
private static String title="t@C̏㏑̊mF";
private int select=2;

public String getFilePath() {
    return filePath;
}
public void setFilePath(String filePath) {
    this.filePath = filePath;
}
private String filePath;
private Button yesButton;
private Button noButton;
private Shell shell;
private Button cancelButton;
private Button yesAllButton;
private Button noAllButton;
public ConfirmFileOverwriteDialog (Shell parent) {
    super (parent, SWT.APPLICATION_MODAL);
    
   
}


public int open () throws IOException {
    if(filePath==null){
        throw new IOException("path not found");
    }
	Shell parent = getParent();
	shell = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
	shell.setSize(380,140);
    shell.setText(title);
    shell.setLayout(new RowLayout());
    Label img=new Label(shell,SWT.NULL);
    img.setImage(new Image(Display.getCurrent(),this.getClass().getClassLoader()
            .getResourceAsStream(
            "org/jpn/xucker/commons/resource/overwrite.png")));
    Label label=new Label(shell,SWT.NULL);
    label.setText(message.replaceAll("%FILE",filePath));
    RowData label_data=new RowData();
    label_data.width=300;
    label.setLayoutData(label_data);
    //
    yesButton=new Button(shell,SWT.NULL);
    yesButton.setText(YES_LABEL);
    yesButton.addSelectionListener(this);
    
    noButton=new Button(shell,SWT.NULL);
    noButton.setText(NO_LABEL);
    noButton.addSelectionListener(this);
    
    cancelButton=new Button(shell,SWT.NULL);
    cancelButton.setText(CANCELL_LABEL);
    cancelButton.addSelectionListener(this);
    
    yesAllButton=new Button(shell,SWT.NULL);
    yesAllButton.setText(ALL_YES_LABEL);
    yesAllButton.addSelectionListener(this);
    
    noAllButton=new Button(shell,SWT.NULL);
    noAllButton.setText(ALL_NO_LABEL);
    noAllButton.addSelectionListener(this);
    
    //this.setMessage(message.replaceAll("%FILE",filePath));
	// Your code goes here (widget creation, set result, etc).
    noButton.setFocus(); //focus
	shell.open();
	Display display = parent.getDisplay();
	while (!shell.isDisposed()) {
		if (!display.readAndDispatch()) display.sleep();
	}
	return select;
}


/* (non-Javadoc)
 * @see org.eclipse.swt.events.SelectionListener#widgetSelected(org.eclipse.swt.events.SelectionEvent)
 */
public void widgetSelected(SelectionEvent e) {
    // TODO Auto-generated method stub
    if(e.getSource()==yesButton){
        select=YES;
    }else if(e.getSource()==noButton){
        select=NO;
    }else if(e.getSource()==cancelButton){
        select=CANCELL;
    }else if(e.getSource()==yesAllButton){
        select=ALL_YES;
    }else if(e.getSource()==noAllButton){
        select=ALL_NO;
    }
   
    shell.close();
}


/* (non-Javadoc)
 * @see org.eclipse.swt.events.SelectionListener#widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent)
 */
public void widgetDefaultSelected(SelectionEvent e) {
    // TODO Auto-generated method stub
    
}



}
