/*
 * 쐬: 2003/10/31
 *
 * ̐ꂽRg̑}ev[gύX邽
 * EBhE > ݒ > Java > R[h > R[hƃRg
 */
package tmp.org.jpn.xucker.commons.audio.wav;

import java.util.Vector;

/**
 * @author akito
 *
 * ̐ꂽRg̑}ev[gύX邽
 * EBhE > ݒ > Java > R[h > R[hƃRg
 */
public class WavData {
private int chunkSize;
private int audioFormat;
private int channel;
private int sampleRate;
private int sampleBits;
//private int extraParamSize;
//

private int blockAlign;
private byte[] data;

private Vector subChunkVec=new Vector();
//private byte[] comment;

//RFC2311
//http://www.zvon.org/tmRFC/RFC2361/Output/chapter8.html
public static int WAVE_FORMAT_UNKNOWN=0;
public static int WAVE_FORMAT_PCM=1;

public String toString(){
	String ret="<Wav\n";
	ret+="chunkSize="+chunkSize+"\n";
	ret+="audioFormat="+audioFormat+"\n";
	ret+="channel="+channel+"\n";
	ret+="sampleRate="+sampleRate+"\n";
	ret+="blockAlign="+blockAlign+"\n";
	ret+="sampleBits="+sampleBits+"\n";
	ret+="dataSize="+getDataSize()+"\n";
	ret+="></Wav>";
	return ret;
}

public void addSubChunk(String id,byte[] bytes){
	SubChunk chunk=new SubChunk(id,bytes);
	subChunkVec.addElement(chunk);
}
public class SubChunk {
	String id;
	byte[] bytes;
	
	/**
	 * @return
	 */
	public byte[] getBytes() {
		return bytes;
	}

	/**
	 * @param id
	 * @param bytes
	 */
	public SubChunk(String id, byte[] bytes) {
		this.id=id;
		this.bytes=bytes;
	}

	/**
	 * @return
	 */
	public String getId() {
		return id;
	}

	/**
	 * @param bs
	 */
	public void setBytes(byte[] bs) {
		bytes = bs;
	}

	/**
	 * @param string
	 */
	public void setId(String string) {
		id = string;
	}

}
/**
 * @return
 */
public int getChunkSize() {
	return chunkSize;
}

/**
 * @param i
 */
public void setChunkSize(int i) {
	chunkSize = i;
}

/**
 * @return
 */
public int getAudioFormat() {
	return audioFormat;
}

/**
 * @return
 */
public int getChannel() {
	return channel;
}

/**
 * @return
 */
public byte[] getData() {
	return data;
}



/**
 * @return
 */
public int getSampleBits() {
	return sampleBits;
}

/**
 * @return
 */
public int getSampleRate() {
	return sampleRate;
}

/**
 * @param i
 */
public void setAudioFormat(int i) {
	audioFormat = i;
}

/**
 * @param i
 */
public void setChannel(int i) {
	channel = i;
}

/**
 * @param bs
 */
public void setData(byte[] bs) {
	data = bs;
}

/**
 * @param i
 */


/**
 * @param i
 */
public void setSampleBits(int i) {
	sampleBits = i;
}

/**
 * @param i
 */
public void setSampleRate(int i) {
	sampleRate = i;
}

/**
 * @return
 */
public int getBlockAlign() {
	return blockAlign;
}

/**
 * @param i
 */
public void setBlockAlign(int i) {
	blockAlign = i;
}

public int getDataSize(){
	return data.length;
}
}
